<template>
  <div>
    <template v-if="isLoading">
      <v-progress-linear
        indeterminate
        color="primary"
      />
    </template>
    <v-simple-table>
      <template v-slot:default>
        <thead>
          <tr>
            <th class="text-center">
              {{ $t('referenceMonth') }}
            </th>
            <th class="text-center">
              <circle-icon :color="incomesSumColor" />
              <span>{{ $t('incomes') }}</span>
            </th>
            <th class="text-center">
              <circle-icon :color="expensesSumColor" />
              <span>{{ $t('expenses') }}</span>
            </th>
            <th class="text-center">
              <circle-icon :color="differenceColor" />
              <span>{{ $t('difference') }}</span>
            </th>
            <th class="text-center">
              <circle-icon :color="accruedColor" />
              <span>{{ $t('accrued') }}</span>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="(item, index) in items"
            :key="index"
          >
            <td class="text-center">
              {{ item.referenceMonth | formatMonth }}
            </td>
            <td class="text-center">
              {{ item.incomesSum | formatCurrency | symbolWhenEmpty }}
            </td>
            <td class="text-center">
              {{ item.expensesSum | formatCurrency | symbolWhenEmpty }}
            </td>
            <td class="text-center">
              {{ item.difference | formatCurrency | symbolWhenEmpty }}
            </td>
            <td class="text-center">
              {{ item.accrued | formatCurrency | symbolWhenEmpty }}
            </td>
          </tr>
        </tbody>
      </template>
    </v-simple-table>
  </div>
</template>

<script>
  import DateMixin from '@/mixins/date'
  import MoneyMixin from '@/mixins/money'
  import UtilsMixin from '@/mixins/utils'

  export default {
    name: 'SimpleTable',
    mixins: [DateMixin, MoneyMixin, UtilsMixin],
    props: {
      isLoading: {
        type: Boolean,
        required: false,
        default: false,
      },
      items: {
        type: Array,
        required: true,
      },
    },
    data () {
      return {
        incomesSumColor: '#fbd2e0',
        expensesSumColor: '#f05b4f',
        differenceColor: '#f4c63d',
        accruedColor: '#d17905',
      }
    },
    i18n: {
      messages: {
        'pt-BR': {
          referenceMonth: 'Mês de referência',
          incomes: 'Receitas',
          expenses: 'Despesas',
          difference: 'Diferença',
          accrued: 'Acumulado',
        },
        'en-US': {
          referenceMonth: 'Reference month',
          incomes: 'Incomes',
          expenses: 'Expenses',
          difference: 'Difference',
          accrued: 'Accrued',
        },
      },
    },
  }
</script>
